%define anolis_release 9
%undefine _package_note_flags
%global qt_module qtwebkit
%global _hardened_build 1

%global __provides_exclude_from ^%{_qt5_archdatadir}/qml/.*\\.so$
%global add_to_license_files() \
        mkdir -p _license_files ; \
        cp -p %1 _license_files/$(echo '%1' | sed -e 's!/!.!g')

Name:           qt5-%{qt_module}
Version:        5.212.0
Release:        %{anolis_release}.alpha4%{?dist}
Summary:        Qt5 - QtWebKit components
License:        LGPLv2 and BSD
URL:            https://github.com/qtwebkit/qtwebkit
Source0:        https://github.com/qtwebkit/qtwebkit/releases/download/%{qt_module}-%{version}-alpha4/%{qt_module}-%{version}-alpha4.tar.xz

Patch0:         qtwebkit-5.212.0_cmake_cmp0071.patch
Patch1:         qtwebkit-5.212.0-json.patch
Patch2:         qtwebkit-bison37.patch
Patch3:         qt5-qtwebkit-glib-2.68.patch
Patch4:         qtwebkit-icu68.patch
Patch100:       Add-support-loongarch64-for-qtwebkit.patch

BuildRequires: bison cmake make findutils gperf
BuildRequires: pngcrush python3 flex
BuildRequires: hyphen-devel libjpeg-devel
BuildRequires: perl-generators rubygems perl(File::Copy)
BuildRequires: pkgconfig(fontconfig) pkgconfig(gio-2.0) pkgconfig(gl)
BuildRequires: pkgconfig(glib-2.0) pkgconfig(gstreamer-1.0)
BuildRequires: pkgconfig(gstreamer-app-1.0) pkgconfig(gstreamer-gl-1.0)
BuildRequires: pkgconfig(gstreamer-mpegts-1.0)
BuildRequires: pkgconfig(libpng) pkgconfig(libwebp) pkgconfig(libwoff2dec)
BuildRequires: pkgconfig(libxslt) pkgconfig(ruby) pkgconfig(sqlite3)
BuildRequires: pkgconfig(xcomposite) pkgconfig(xrender) pkgconfig(zlib)
BuildRequires: pkgconfig(icu-i18n) pkgconfig(icu-uc)
BuildRequires: qt5-qtbase-devel qt5-qtbase-private-devel
BuildRequires: qt5-qtdeclarative-devel qt5-qtdeclarative-private-devel

%if ! 0%{?bootstrap}
BuildRequires:  qt5-qtlocation-devel qt5-qtsensors-devel qt5-qtwebchannel-devel
%endif
%{?_qt5:Requires: %{_qt5} = %{_qt5_version}}
%{?_qt5:Requires: qt5-qtdeclarative = %{_qt5_version}}

%description
WebKit is an open source web browser engine. WebKit's HTML and JavaScript
code began as a branch of the KHTML and KJS libraries from KDE. As part of
KDE framework KHTML was based on Qt but during their porting efforts Apple's
engineers made WebKit toolkit independent.
QtWebKit is a project aiming at porting this fabulous engine back to Qt.

The Qt port of WebKit currently compiles and runs on Linux, *BSD, Windows
and macOS.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       qt5-qtbase-devel
Requires:       qt5-qtdeclarative-devel

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%if 0%{?docs}
%package doc
Summary: API documentation for %{name}
BuildRequires: qt5-qdoc
BuildRequires: qt5-qhelpgenerator
BuildArch: noarch

%description doc
The %{name}-doc package contains documentation files for %{name}.
%endif

%prep
%autosetup -p1 -n %{qt_module}-%{version}-alpha4

find -name \*.png | xargs -n1 pngcrush -ow -fix
rm -fr Source/ThirdParty/{brotli,woff2}

%build
%define _lto_cflags %{nil}
%define _package_note_flags %{nil}

# The following changes of optflags ietc. are adapted from webkitgtk4 package, which
# is mostly similar to this one...
#
# Increase the DIE limit so our debuginfo packages could be size optimized.
# Decreases the size for x86_64 from ~5G to ~1.1G.
%global _dwz_max_die_limit 250000000

CFLAGS="${CFLAGS:-%optflags}" ; export CFLAGS ;
CXXFLAGS="${CXXFLAGS:-%optflags} -fpermissive" ; export CXXFLAGS ;
%{?__global_ldflags:LDFLAGS="${LDFLAGS:-%__global_ldflags}" ; export LDFLAGS ;}

%cmake \
       -DPORT=Qt \
       -DCMAKE_BUILD_TYPE=Release \
       -DENABLE_TOOLS=OFF \
%ifarch loongarch64
       -DENABLE_JIT=OFF \
%endif
       -DCMAKE_C_FLAGS_RELEASE:STRING="-DNDEBUG" \
       -DCMAKE_CXX_FLAGS_RELEASE:STRING="-DNDEBUG" \
       -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
       %{?docs:-DGENERATE_DOCUMENTATION=ON} \
       -DPYTHON_EXECUTABLE:PATH="%{__python3}"

%cmake_build

%if 0%{?docs}
%make_build docs
%endif

%install
%cmake_install

sed -i "s,Libs: -L%{_qt5_libdir}/qt5/../ -lQt5WebKit,Libs: -L%{_qt5_libdir} -lQt5WebKit ,g" \
	%{buildroot}%{_libdir}/pkgconfig/Qt5WebKit.pc
sed -i "s,Libs: -L%{_qt5_libdir}/qt5/../ -lQt5WebKitWidgets,Libs: -L%{_qt5_libdir} -lQt5WebKitWidgets ,g" \
	%{buildroot}%{_libdir}/pkgconfig/Qt5WebKitWidgets.pc

%add_to_license_files Source/JavaScriptCore/COPYING.LIB
%add_to_license_files Source/JavaScriptCore/icu/LICENSE
%add_to_license_files Source/ThirdParty/ANGLE/LICENSE
%add_to_license_files Source/ThirdParty/ANGLE/src/third_party/compiler/LICENSE
%add_to_license_files Source/ThirdParty/ANGLE/src/third_party/murmurhash/LICENSE
%add_to_license_files Source/WebCore/icu/LICENSE
%add_to_license_files Source/WebCore/LICENSE-APPLE
%add_to_license_files Source/WebCore/LICENSE-LGPL-2
%add_to_license_files Source/WebCore/LICENSE-LGPL-2.1
%add_to_license_files Source/WebInspectorUI/UserInterface/External/CodeMirror/LICENSE
%add_to_license_files Source/WebInspectorUI/UserInterface/External/Esprima/LICENSE
%add_to_license_files Source/WTF/icu/LICENSE
%add_to_license_files Source/WTF/wtf/dtoa/COPYING
%add_to_license_files Source/WTF/wtf/dtoa/LICENSE

%check
export PKG_CONFIG_PATH=%{buildroot}%{_libdir}/pkgconfig
test -z "$(pkg-config --cflags Qt5WebKit | grep Qt5WebKit)"

%files
%{_qt5_libdir}/libQt5WebKit.so.5*
%{_qt5_libdir}/libQt5WebKitWidgets.so.5*
%{_qt5_libexecdir}/QtWebNetworkProcess
%{_qt5_libexecdir}/QtWebPluginProcess
%{_qt5_libexecdir}/QtWebProcess
%{_qt5_libexecdir}/QtWebStorageProcess
%{_qt5_archdatadir}/qml/QtWebKit/
%license LICENSE.LGPLv21 _license_files/*

%files devel
%{_qt5_headerdir}/Qt*/
%{_qt5_libdir}/libQt5*.so
%{_qt5_libdir}/cmake/Qt5*/
%{_qt5_libdir}/pkgconfig/Qt5*.pc
%{_qt5_archdatadir}/mkspecs/modules/*.pri

%if 0%{?docs}
%files doc
%{_qt5_docdir}/qtwebkit.qch
%{_qt5_docdir}/qtwebkit/
%endif

%changelog
* Thu Oct 19 2023 Funda Wang <fundawang@yeah.net> - 5.212.0-9.alpha4
- Rebuild for qt 5.15.11

* Tue Sep 5 2023 Jingyun Hua <huajingyun@loongson.cn> - 5.212.0-8.alpha4
- support loongarch64 for qtwebkit

* Wed May 24 2023 Funda Wang <fundawang@yeah.net> - 5.212.0-7.alpha4
- Rebuild for new qt 5.15.9

* Fri Apr 14 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 5.212.0-6.alpha4
- Refactor the specfile

* Tue Mar 28 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 5.212.0-5.alpha4
- Del Specific Fields

* Fri Jan 20 2023 Funda Wang <fundawang@yeah.net> - 5.212.0-4.alpha4
- Drop unused third-party libs

* Fri Jan 20 2023 Funda Wang <fundawang@yeah.net> - 5.212.0-3.alpha4
- Rebuild for new qt 5.15.8

* Thu Dec 8 2022 Funda Wang <fundawang@yeah.net> - 5.212.0-2.alpha4
- Rebuild for new qt 5.15.7

* Fri Jul 29 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 5.212.0-1.alpha4
- Init from upstream version 5.212.0
